program PExample;

	uses
		Types, Files, Packages, Aliases, 
		ICTypes, ICKeys, ICAPI;

	var
		inst: ICInstance;

	procedure DumpPrefs;
		var
			count: longint;
			i: longint;
			key: Str255;
	begin
		writeln('ICCountPref: ', ICCountPref(inst, count) : 1);
		for i := 1 to count do begin
			write('  ICGetIndPref: ', ICGetIndPref(inst, i, key) : 1, ' - ');
			writeln(key);
		end; (* for *)
	end; (* DumpPrefs *)

	procedure TestPascal;
		var
			err : ICError;
			email_address: Str255;
			attr: longint;
			size: longint;
			seed: longint;
			mappings: handle;
			entry: ICMapEntry;
	begin
		writeln('ICStart: ', ICStart(inst, 'CREA') : 1);		(* tell it your application creator *)
		writeln('ICFindConfigFile: ', ICFindConfigFile(inst, 0, nil) : 1);
	
		writeln('ICBegin: ', ICBegin(inst, icReadWritePerm) : 1);
		size := sizeof(email_address);
		err := ICGetPref(inst, kICEmail, attr, @email_address, size);
		writeln('ICGetPref: ', err : 1);
		if err = noErr then begin
			writeln('Your Email address is ', email_address);
		end; (* if *)
	
		DumpPrefs;
		writeln('ICEnd: ', ICEnd(inst) : 1);
	
		writeln('ICGetSeed: ', ICGetSeed(inst, seed) : 1, ' = ', seed : 1);
		(* now monitor this seed to see if any preferences have changed *)
	
		writeln('ICStop: ', ICStop(inst));
	end;
	
	procedure TestC; C; external;
		
begin
	writeln('Testing Pascal');
	TestPascal;
	writeln;
{$ifc false}
	writeln('Testing C');
	TestC;
{$endc}
end. (* PExample *)